def var ch1 as char label "Numeric format".
def var ch2 as char label "Decimal point".
def var ch3 as char label "Numeric separator".
def var ch as char.
def var caz as int label "Case #".
def var d as dec label "Decimal" init 12345678.09 format ">>>,>>>,>>>.99".

form caz ch1 ch2 ch3 d with frame f1 down title "Numeric separators".

function checkMe returns int (i as int, ns as char, ds as char, nf as char, df as char).
   display i @ caz nf @ ch1 ds @ ch2 ns @ ch3 d with frame f1.
  
   if (session:numeric-decimal-point <> ds)
     then message string(i) ": expected decimal point " ds " and found " session:numeric-decimal-point.
     
   if (session:numeric-separator <> ns)
     then message string(i) ": expected numeric separator " ns " and found " session:numeric-separator.
  
   if (session:numeric-format <> nf)
     then message string(i) ": expected numeric format " nf " and found " session:numeric-format.
     
   def var sdf as char.
   sdf = trim(string(d, ">>>,>>>,>>>.99")).
   if (sdf <> df)
     then message string(i) ": expected " df " and found " sdf.

   sdf = d:screen-value in frame f1.
   if (sdf <> df)
     then message string(i) ": expected " df " and found screen-value " sdf.

   down with frame f1.
end.

/* initial values */
checkMe(0, session:numeric-separator, session:numeric-decimal-point, session:numeric-format, "12,345,678.09").

ch = ?.
session:numeric-format = ch.
checkMe(1, ",", ".", "AMERICAN", "12,345,678.09").

ch = "bar".
session:numeric-format = ch.
checkMe(2, ",", ".", "AMERICAN", "12,345,678.09").

ch = "b".
session:numeric-format = ch.
checkMe(3, ",", ".", "AMERICAN", "12,345,678.09").

ch = "AMERICAN".
session:numeric-format = ch.
checkMe(4, ",", ".", "AMERICAN", "12,345,678.09").

ch = "EUROPEAN".
session:numeric-format = ch.
checkMe(5, ".", ",", "EUROPEAN", "12.345.678,09").

ch = "american".
session:numeric-format = ch.
checkMe(6, ",", ".", "AMERICAN", "12,345,678.09").

ch = "european".
session:numeric-format = ch.
checkMe(7, ".", ",", "EUROPEAN", "12.345.678,09").
